;
;	Kpnz program VT-DOS-ra s UPM-re
;
;
;
	.org 0100h			; a VT-DOS programok betltsi cme

pmain:	ld	sp,07FF0h		; sajt veremterlet kialaktsa U1 tetejn
	ld	a,0B0h			; U0,U1,U2,U3 lapozs
	ld	(0003Bh),a		; felhasznli lapoz rtk bersa (UPM miatt)
	ld	de,0005Ch		; DE az els paramterben megadott fjlnv FCB-re mutat
	ld	c,00Fh			; funkcikd: fjl megnyitsa
	call	0005h			; VT-DOS hvsa
	cp	0FFh
	jr	z,exit			; ugrs, ha nem sikerlt megnyitnia
	ld	de,puffer		; DE a zefile betltsi cmre mutat
folv:	push	de
	ld	c,01Ah			; funkcikd: diszk tviteli cm belltsa
	call	0005h			; VT-DOS hvsa
	ld	de,0005Ch		; DE az FCB-re mutat
	ld	c,014h			; funkcikd: szekvencilis olvass
	call	0005h			; VT-DOS hvsa
	pop	de
	or	a
	jr	nz,beolvas		; ugrs, ha vge a fjlnak
	ld	hl,00080h		; tviteli cm nvelse 128-al
	add	hl,de
	ex	de,hl
	ld	hl,06800h		; HL= fels memriahatr
	sbc	hl,de
	jr	nc,folv			; ismtls a maximlisan olvashat hosszig
;
beolvas: push	de			; olvass vgcme a verembe
	call	ed_dosoff		; VT-DOS kurzor kikapcsolsa
	pop	hl			; vgcm HL-be
	ld	de,puffer		; DE a kpfjl betltsi cmre mutat
	or	a
	sbc	hl,de			; HL= olvasott hossz
	ex	de,hl			; DE s HL felcserlse

	ld	e,12
	ld	c,2
	call	5
	ld	e,31
	ld	c,2
	call	5

	ld	de,jatszunk
	ld	c,0009h
	call	0005h

	call	player			; lejtszs

	ld	e,12
	ld	c,2
	call	5
	ld	e,31
	ld	c,2
	call	5

	ld	de,vege
	ld	c,0009h
	call	0005h

	ld	c,0001h
	call	0005h
	ld	c,000h			; 2-szn md belltsa
	call	kepmod
	call	ed_doson		; VT-DOS kurzor bekapcsolsa
;
exit:	jp	0000h			; vissza a VT-DOS-ba
;
vege:	.db	"Press to end!$"
;
;	VT-DOS konzol kurzor kikapcsolsa
;	in:  -
;	out: -
;
ed_dosoff:
	ld	de,curoff
	jr	ed_str
;
;	VT-DOS konzol kurzor bekapcsolsa
;	in:  -
;	out: -
;
ed_doson:
	ld	de,curon
ed_str:	ld	c,009h			; C= funkcikd: string output
	call	0005h			; VT-DOS hvsa
	ret
;
;	ESC szekvencik a kurzor be/ki kapcsolshoz
;

curoff:	.db	012h			; kurzor kikapcsolsa UPM-en
	.db	01Bh,"x5"		; kurzor kikapcsolsa VT-DOS-on
	.db	00Ch			; kperny trlse (HOME UPM-en)
	.db	'$'			; stringet zr '$' karakter

curon:	.db	011h			; kurzor bekapcsolsa UPM-en
	.db	01Bh,"y5"		; kurzor bekapcsolsa VT-DOS-on
	.db	01Fh			; kperny trlse UPM-en
	.db	00Ch			; kperny trlse (HOME UPM-en)
	.db	'$'			; stringet zr '$' karakter
;
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
player:		DI                                    ; <- 100H IT disabled
                PUSH	IX                            ; save for basic                       
                XOR     A                             ; a = 0
                OUT     (5),A                         ; Sound IT disabled, sound is OFF
                LD      C,A                           
                LD      IX,puffer  		      ;MELODY                     
                                   
NEXT_RECORD	XOR     A                             
                LD      C,A                           
                LD      H,A                           
                LD      L,A                           
                LD      D,(IX+0)                      ; freq1 -> D
                LD      E,(IX+1)                      ; freq2 -> E                         
                LD      B,(IX+2)                      ; duration -> B
;
; LOOP is fix 252 cycle long. All conditional relative jump is time balanced
;
LOOP            LD      A,H                           ; downmix chn1 + 2
                ADD     A,L                           
                RR      A                             ; divide by 2
                AND     60                            ; mask with 00111100 
                OR      0                             ; in 2 (4) color mode
                OUT     (6),A                         ; write mixed value to the D/A port     
;
                INC     D                             ; if freq = 0 then NOSOUND for chn1
                DEC     D                             
                JR      Z,TIMING_BALANCE1             
                LD      A,L                           ; (4) generate square waveform for CHN1
                XOR     60                            ; (7)  
                DEC     D                             ; (4) check freq counter
                JR      NZ,TIMING_BALANCE11           ; (12)
                LD      L,A                           ; (4)
                LD      D,(IX+0)                      ; (19) reset freq1 counter
                JR      LOOP1                         ; (12)
TIMING_BALANCE1 LD      A,(IX+0)                      ; waste (27) cycle to balance timing
                NOP                                               
                NOP                                               
TIMING_BALANCE11 LD     A,(IX+0)                      ; waste (35) cycle to balance timing                                     
                NOP                                               
                NOP                                               
                NOP                                               
                NOP                                               
                                   
LOOP1           INC      E                             ; if freq = 0 then NOSOUND for cnh2
                DEC      E                             
                JR       Z,TIMING_BALANCE2             
                LD       A,H                           ; (4) generate square waveform for CHN2
                XOR      60                            ; (7)  
                DEC      E                             ; (4) check freq counter
                JR       NZ,TIMING_BALANCE22           ; (12)
                LD       H,A                           ; (4)
                LD       E,(IX+1)                      ; (19) reset freq2 counter
                JR       LOOP2                         ; (12)
TIMING_BALANCE2 LD       A,(IX+0)                      ; waste (27) cycle to balance timing
                NOP                                               
                NOP                                               
TIMING_BALANCE22 LD      A,(IX+0)                      ; waste (35) cycle to balance timing                                     
                NOP                                               
                NOP                                               
                NOP                                               
                NOP                                               
                                   
LOOP2           DEC       C                             ; duration downcounter                
                JR        NZ,GO_TO_LOOP                 ; count down (duration * 256)
                DJNZ      GO_TO_LOOP2                   ; (13)
                JR        NEXT                          ; (12)                   
GO_TO_LOOP      NOP                                               ; waste (24) cycle to balance timing
                NOP                                               
                NOP                                               
GO_TO_LOOP2     NOP                                               
                NOP                                               
                NOP                                               
                JP        LOOP                          
NEXT            LD        BC,3                          ; IX = IX + 3 (next melody record) 
                ADD       IX,BC                         
                LD        A,(IX+0)                      ; check end of music (255)
                INC       A                             
                JR        Z,FINISH                      
                JP        NEXT_RECORD                   
                                   
FINISH          POP       IX                            
                EI                                          
                RET          
;
jatszunk:	.db	"Melodi Player / Mplay file.ext$"
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;
;	Videmd belltsa s a kperny trlse
;	in:   C - videmd
;	out: HL - megrzdik
;
kepmod:	push	hl
	push	bc			; videmd a verembe
	ld	a,(0003Bh)		; eredeti lapozs A reg.-be
	push	af			; lapozs mentse a verembe
	ld	a,090h			; memrialapozs: U0, U1, VID, U3
	ld	(0003Bh),a		; j felhasznli lapozs belltsa
	ld	hl,08000h		; kperny trlse
	ld	de,08001h
	ld	bc,03BFFh
	di				; megszakts tiltsa (csak UPM-en szksges)
	out	(002h),a		; lapozs a porton
	ld	a,000h			; A reg.= kitltbjt
	ld	(hl),a
	ldir
	pop	af			; felhasznli lapozs vissza
	ld	(0003Bh),a
	out	(002h),a
	ei
	ld	hl,defpal		; HL a belltand alap palettra mutat
	ld	c,060h			; C= paletta-regiszterek I/O cme
	outi				; palettaregiszterek belltsa
	inc	c
	outi
	inc	c
	outi
	inc	c
	outi
	pop	bc
	ld	a,c
	out	(006h),a		; zemmd belltsa (+hang amplitd nullzsa)
	pop	hl
	ret
;
defpal	.db	000h, 050h, 044h, 041h	; palettaregiszterek alaprtkei

freemem	.equ	$			; az els szabad memricm a programkd utn
;
puffer	.equ	freemem
		; example

.end

